
import { Subject } from 'rxjs';
import { GeneralEvent, MessageReceiverInterface, MessageRequestResponseInterface, MessageTransmissionInterface, MessageTransmissionManagerInterface, MessageTransmitterInterface, TransmissionProfile } from '../interface/interface';
import { AdapterManager } from '../adapters/adapter.manager';
import ConsoleLogger from '../utils/log.utils';

export class MessageTransmissionManagerBase implements MessageTransmissionManagerInterface {
    protected console!: ConsoleLogger
    protected browserEnv!: boolean
    protected transmissionRef: MessageTransmissionInterface[] = []
    protected adapterManager!: AdapterManager
    protected event!: Subject<GeneralEvent<any>>

    constructor() {
        // logic here
    }
    
    getTransmitter(profile: TransmissionProfile): MessageTransmitterInterface {
        throw new Error(`Method not implemented`)
    }

    getReceiver(profile: TransmissionProfile): MessageReceiverInterface {
        throw new Error(`Method not implemented`)
    }

    getRequestResponse(profile: TransmissionProfile, transmitterInstance: MessageTransmitterInterface, receiverInstance: MessageReceiverInterface): MessageRequestResponseInterface {
        throw new Error(`Method not implemented`)
    }

}